var GIFT_CENTER = 0;
var GIFT_LEFT = 1;
var GIFT_RIGHT = 2;

function CGift(oSprite, iOffset, iZ, iSpeed, oElementContainer){

    var _iOffset;
    var _iZ;
    var _iSpeed;
    var _iPercent;

    var _aSprite;

    var _oParent;
    var _oGift;
    var _oCurSprite;

    var _isCaptured = false;

    this._init = function(oSprite, iOffset, iZ, iSpeed, oElementContainer){
        _iOffset = iOffset;
        _iZ = iZ;
        _iSpeed = iSpeed;

        _aSprite = new Array();
        _aSprite[GIFT_CENTER] = s_oSpriteLibrary.getSprite(oSprite+"_center");
        _aSprite[GIFT_LEFT] = s_oSpriteLibrary.getSprite(oSprite+"_left");
        _aSprite[GIFT_RIGHT] = s_oSpriteLibrary.getSprite(oSprite+"_right");

        _oCurSprite = _aSprite[GIFT_CENTER];

        _oGift = createBitmap(_oCurSprite);
        _oGift.x = 500;
        _oGift.visible = false;
        oElementContainer.addChild(_oGift);
    };

    this.getGift = function(){
        return _oGift;
    };

    this.getSprite = function(){
        return _oCurSprite;
    };

    this.getOffset = function(){
        return _iOffset;
    };

    this.getZ = function(){
        return _iZ;
    };

    this.getSpeed = function(){
        return _iSpeed;
    };

    this.getPercent = function(){
        return _iPercent;
    };

    this.setDirection = function(iDir){
        _oCurSprite = _aSprite[iDir];
        _oGift.image = _aSprite[iDir];
    };

    this.setVisible = function(bVal){
        _oGift.visible = bVal;
    };

    this.setIsCaptured = function(isCaptured) {
      this._isCaptured = isCaptured;
    }

    this.getIsCaptured = function() {
      return this._isCaptured;
    }

    this.updateGiftOffset = function(giftSegment, oPlayer) {

      var i, j, dir, segment, otherGift, otherGiftW, lookahead = 20, giftW = _oParent.getSprite().width * SPRITES.SCALE, aSegments;

      if ((giftSegment.index - oPlayer.getPlayerSegment().index) > DRAW_DISTANCE){
            //////SET VISIBLE TO FALSE, PREVENT TO SEE GIFTS IF ARE NOT IN SIGHT VIEW.
            _oGift.visible = false;
            return 0;
      }


      for(i = 1 ; i < lookahead ; i++) {
          aSegments = s_oGame.getSegments();
          segment = aSegments[(giftSegment.index+i)%aSegments.length];

        if ((segment === oPlayer.getPlayerSegment()) && (_iSpeed > oPlayer.getCurSpeed()) && (Util.overlap(oPlayer.getPosition().x, oPlayer.getPlayerWidth(), _iOffset, giftW, 1.2))) {

          if (oPlayer.getPosition().x > 0.5)
            dir = -1;
          else if (oPlayer.getPosition().x < -0.5)
            dir = 1;
          else
            dir = (_iOffset > oPlayer.getPosition().x) ? 1 : -1;

          return dir * 1/i * (_iSpeed-oPlayer.getCurSpeed())/oPlayer.getMaxSpeed(); // the closer the gifts (smaller i) and the greated the speed ratio, the larger the offset
        }

        for(j = 0 ; j < segment.gifts.length ; j++) {
          otherGift  = segment.gifts[j];
          otherGiftW = otherGift.getSprite().width * SPRITES.SCALE;

          if ((_iSpeed > otherGift.getSpeed()) && Util.overlap(_iOffset, giftW, otherGift.getOffset(), otherGiftW, 1.2)) {
            if (otherGift.getOffset() > 0.5)
              dir = -1;
            else if (otherGift.getOffset() < -0.5)
              dir = 1;
            else
              dir = (_iOffset > otherGift.getOffset()) ? 1 : -1;
            return dir * 1/i * (_iSpeed-otherGift.getSpeed())/oPlayer.getMaxSpeed();
          }
        }
      }

      // if no gifts ahead, but I have somehow ended up off road, then steer back on
      if (_iOffset < -0.9)
        return 0.1;
      else if (_iOffset > 0.9)
        return -0.1;
      else
        return 0;
    };

    this.update = function(dt, oPlayer){
        var oldSegment  = s_oGame.findSegment(_iZ);

        _iOffset  = _iOffset + this.updateGiftOffset(oldSegment, oPlayer);
        _iZ       = Util.increase(_iZ, dt * _iSpeed, TRACK_LENGTH);

        _iPercent = Util.percentRemaining(_iZ, SEGMENT_LENGTH); // useful for interpolation during rendering phase
        var newSegment  = s_oGame.findSegment(_iZ);
        if (oldSegment !== newSegment) {
          var index = oldSegment.gifts.indexOf(_oParent);
          oldSegment.gifts.splice(index, 1);
          newSegment.gifts.push(_oParent);
        }

    };
    _oParent = this;
    this._init(oSprite, iOffset, iZ, iSpeed, oElementContainer);
}


