function CLosePanel(_iGiftsCaptured, _iCarsHitted){
    
    var _oFade;
    var _oPanelContainer;
    // var _oExitBut;
    var _oRestartBut;
    var _oParent;
    
    var _pStartPanelPos;
    this._init = function(_iGiftsCaptured, _iCarsHitted){
        
        setVolume(s_aSounds["game_soundtrack"], SOUNDTRACK_VOLUME_IN_GAME);
        
        _oFade = new createjs.Shape();
        _oFade.graphics.beginFill("black").drawRect(0,0,CANVAS_WIDTH,CANVAS_HEIGHT);
        _oFade.alpha = 0;
        _oFade.on("mousedown",function(){});
        s_oStage.addChild(_oFade);
        
        new createjs.Tween.get(_oFade).to({alpha:0.7},500);
        
        _oPanelContainer = new createjs.Container();
        s_oStage.addChild(_oPanelContainer);
        
        var oSprite = s_oSpriteLibrary.getSprite('msg_box_large');
        var oPanel = createBitmap(oSprite);        
        oPanel.regX = oSprite.width/2;
        oPanel.regY = oSprite.height/2;
        _oPanelContainer.addChild(oPanel);

        _oPanelContainer.x = CANVAS_WIDTH/2;
        _oPanelContainer.y = CANVAS_HEIGHT + oSprite.height/2;
        _pStartPanelPos = {x: _oPanelContainer.x, y: _oPanelContainer.y};
        new createjs.Tween.get(_oPanelContainer).to({y:CANVAS_HEIGHT/2},500, createjs.Ease.quartIn);

        if(_iGiftsCaptured.length == 0) {
            var oSprite = s_oSpriteLibrary.getSprite('baloon_mc');
            var oExplosion = createBitmap(oSprite);
            oExplosion.regX = oSprite.width/2;
            oExplosion.regY = oSprite.height/2;
            oExplosion.y = -100;
            oExplosion.x = -30;
            oExplosion.scaleX = oExplosion.scaleY = 0.6;
            _oPanelContainer.addChild(oExplosion);
        }


        var oTitle1 = new CTLText(_oPanelContainer,
                    -400, -290, 800, 100,
                    50, "center", "#fff", PRIMARY_FONT, 1,
                    0, 0,
                    TEXT_TIME_IS_UP,
                    true, true, true,
                    false );

        if( _iGiftsCaptured.length ) {
            var oTitle2 = new CTLText(_oPanelContainer,
                        -390, -220, 800, 100,
                        50, "center", "#fff", PRIMARY_FONT, 1,
                        0, 0,
                        TEXT_GIFTS_CATCHED,
                        true, true, true,
                        false );

            // Renderizar cada regalo como una imagen en línea
            var iGiftSpacing = 220; // Espacio entre cada regalo
            var iInitialX = -550;   // Posición inicial en el eje X

            for (var i = 1; i <= 4; i++) {
                var giftName = "gift0" + i + "_hd_slot";
                var oGiftSprite = s_oSpriteLibrary.getSprite(giftName);
    
                var oGiftImage = createBitmap(oGiftSprite);
                oGiftImage.regX = oGiftSprite.width / 2;
                oGiftImage.regY = oGiftSprite.height / 2;
                oGiftImage.x = iInitialX + (i * iGiftSpacing); // Posición inicial ajustada
                oGiftImage.y = -50;
                oGiftImage.scaleX = oGiftImage.scaleY = 0.7;
                _oPanelContainer.addChild(oGiftImage);
            }
            for (var i = 0; i < _iGiftsCaptured.length; i++) {
                var giftName = _iGiftsCaptured[i] + "_hd";
                var oGiftSprite = s_oSpriteLibrary.getSprite(giftName); // Asume que 'gift' es el sprite para un regalo
                var oGiftImage = createBitmap(oGiftSprite);
                oGiftImage.regX = oGiftSprite.width / 2;
                oGiftImage.regY = oGiftSprite.height / 2;
                oGiftImage.x = iInitialX + ((i + 1) * iGiftSpacing); // Posición inicial ajustada
                oGiftImage.y = -50;
                oGiftImage.scaleX = oGiftImage.scaleY = 0.7;
                _oPanelContainer.addChild(oGiftImage);
            }
        }

        if( _iCarsHitted.length ) {
            var oTitle3 = new CTLText(_oPanelContainer,
                        -400, 20, 800, 80,
                        50, "center", "#fff", PRIMARY_FONT, 1,
                        0, 0,
                        TEXT_CARS_HITTED,
                        true, true, true,
                        false );
    
            var iGiftSpacing = 180; // Espacio entre cada regalo
            for(var i=0; i<_iCarsHitted.length; i++){
                var oSprite = s_oSpriteLibrary.getSprite(_iCarsHitted[i] + "_center");
                var oCar = createBitmap(oSprite);
                oCar.regX = oSprite.width/2;
                oCar.regY = oSprite.height/2;
                oCar.x = -350 + (i * iGiftSpacing); // Posición inicial ajustada
                oCar.y = 170;
                // oCar.scaleX = oCar.scaleY = 0.7;
                _oPanelContainer.addChild(oCar);
            }
        }
        // var oSprite = s_oSpriteLibrary.getSprite('but_exit');
        // _oExitBut = new CGfxButton(460, -320, oSprite,_oPanelContainer);
        // _oExitBut.addEventListener(ON_MOUSE_UP, this._onExit, this);

        var oSprite = s_oSpriteLibrary.getSprite('but_restart');
        _oRestartBut = new CGfxButton(460, -320, oSprite,_oPanelContainer);
        _oRestartBut.addEventListener(ON_MOUSE_UP, this._onRestart, this);
        _oRestartBut.pulseAnimation();
        
    };
    
    this.unload = function(){
        s_oStage.removeChild(_oPanelContainer);
        _oFade.off("mousedown",function(){});
        
        // _oExitBut.unload();
        _oRestartBut.unload();
    };

    
    this.show = function(){
        playSound("arrive_lose",1,0);
    };
    
    this._onExit = function(){

        _oFade.off("mousedown",function(){});
        s_oStage.removeChild(_oPanelContainer);
        
        s_oGame.onExit();
    };
    
    this._onRestart = function(){
        _oRestartBut.setClickable(false);
        // _oExitBut.setClickable(false);

        new createjs.Tween.get(_oFade).to({alpha:0},500);
        new createjs.Tween.get(_oPanelContainer).to({y:_pStartPanelPos.y},400, createjs.Ease.backIn).call(function(){
            _oParent.unload();
            s_oGame.restartGame();
        });
    };
    
    _oParent = this;
    this._init(_iGiftsCaptured, _iCarsHitted);
    
    return this;
}
