function CNextLevelPanel(iTimeElaps, iScore, iLevel, _iGiftsCaptured, _iCarsHitted){

    var _oPanelContainer;
    var _oFade;
    var _oParent;
    var _oAchievementStars;
    // var _oContinueBut;
    var _oRestartBut;

    var _pStartPanelPos;
    this._init = function(iTimeElaps, iScore, iLevel, _iGiftsCaptured, _iCarsHitted){

        playSound("arrive_win", 1, false);
        setVolume(s_aSounds["game_soundtrack"], SOUNDTRACK_VOLUME_IN_GAME);

        _oFade = new createjs.Shape();
        _oFade.graphics.beginFill("black").drawRect(0,0,CANVAS_WIDTH,CANVAS_HEIGHT);
        _oFade.alpha = 0;
        _oFade.on("mousedown",function(){});
        s_oStage.addChild(_oFade);

        new createjs.Tween.get(_oFade).to({alpha:0.7},500);

        _oPanelContainer = new createjs.Container();
        s_oStage.addChild(_oPanelContainer);

        var oSprite = s_oSpriteLibrary.getSprite('msg_box_large');
        var oPanel = createBitmap(oSprite);
        oPanel.regX = oSprite.width/2;
        oPanel.regY = oSprite.height/2;
        _oPanelContainer.addChild(oPanel);

        _oPanelContainer.x = CANVAS_WIDTH/2;
        _oPanelContainer.y = CANVAS_HEIGHT + oSprite.height/2;
        _pStartPanelPos = {x: _oPanelContainer.x, y: _oPanelContainer.y};

        var oTitle = new CTLText(_oPanelContainer,
                    -440, -280, 600, 40,
                    40, "center", "#fff", PRIMARY_FONT, 1,
                    0, 0,
                    TEXT_TRACK_COMPLETED,
                    true, true, false,
                    false );


        var oTimerContainer = new createjs.Container();
        oTimerContainer.x = 220;
        oTimerContainer.y = -260;
        _oPanelContainer.addChild(oTimerContainer);

        var oSprite = s_oSpriteLibrary.getSprite('timer');
        var oTimer = createBitmap(oSprite);
        oTimer.regX = oSprite.width/2;
        oTimer.regY = oSprite.height/2;
        oTimerContainer.addChild(oTimer);

        var iTime = LEVEL_INFO[iLevel].time - iTimeElaps

        var oTimeText = new CTLText(oTimerContainer,
                    34, -20, 150, 50,
                    50, "left", "#fff", PRIMARY_FONT, 1,
                    0, 0,
                    formatTime(iTime),
                    true, true, false,
                    false );



        // var oScoreContainer = new createjs.Container();
        // oScoreContainer.x = 120;
        // oScoreContainer.y = oTimerContainer.y;
        // _oPanelContainer.addChild(oScoreContainer);

        // var oSprite = s_oSpriteLibrary.getSprite('star');
        // var oStar = createBitmap(oSprite);
        // oStar.regX = oSprite.width/2;
        // oStar.regY = oSprite.height/2;
        // oScoreContainer.addChild(oStar);

        // var oScoreText =  new CTLText(oScoreContainer,
        //             34, -20, 150, 50,
        //             50, "left", "#fff", PRIMARY_FONT, 1,
        //             0, 0,
        //             "0",
        //             true, true, false,
        //             false );

        if( _iGiftsCaptured.length ) {
            var oTitle2 = new CTLText(_oPanelContainer,
                        -390, -220, 800, 100,
                        50, "center", "#fff", PRIMARY_FONT, 1,
                        0, 0,
                        TEXT_GIFTS_CATCHED,
                        true, true, true,
                        false );

            // Renderizar cada regalo como una imagen en línea
            var iGiftSpacing = 220; // Espacio entre cada regalo
            var iInitialX = -550;   // Posición inicial en el eje X

            for (var i = 1; i <= 4; i++) {
                var giftName = "gift0" + i + "_hd_slot";
                var oGiftSprite = s_oSpriteLibrary.getSprite(giftName);

                var oGiftImage = createBitmap(oGiftSprite);
                oGiftImage.regX = oGiftSprite.width / 2;
                oGiftImage.regY = oGiftSprite.height / 2;
                oGiftImage.x = iInitialX + (i * iGiftSpacing); // Posición inicial ajustada
                oGiftImage.y = -50;
                oGiftImage.scaleX = oGiftImage.scaleY = 0.7;
                _oPanelContainer.addChild(oGiftImage);
            }
            for (var i = 0; i < _iGiftsCaptured.length; i++) {
                var giftName = _iGiftsCaptured[i] + "_hd";
                var oGiftSprite = s_oSpriteLibrary.getSprite(giftName); // Asume que 'gift' es el sprite para un regalo
                var oGiftImage = createBitmap(oGiftSprite);
                oGiftImage.regX = oGiftSprite.width / 2;
                oGiftImage.regY = oGiftSprite.height / 2;
                oGiftImage.x = iInitialX + ((i + 1) * iGiftSpacing); // Posición inicial ajustada
                oGiftImage.y = -50;
                oGiftImage.scaleX = oGiftImage.scaleY = 0.7;
                _oPanelContainer.addChild(oGiftImage);
            }
        }

        // Renderizar cada auto chocado como una imagen en línea
        if( _iCarsHitted.length ) {
            var oTitle3 = new CTLText(_oPanelContainer,
                        -400, 20, 800, 80,
                        50, "center", "#fff", PRIMARY_FONT, 1,
                        0, 0,
                        TEXT_CARS_HITTED,
                        true, true, true,
                        false );
    
            var iGiftSpacing = 180; // Espacio entre cada regalo
            for(var i=0; i<_iCarsHitted.length; i++){
                var oSprite = s_oSpriteLibrary.getSprite(_iCarsHitted[i] + "_center");
                var oCar = createBitmap(oSprite);
                oCar.regX = oSprite.width/2;
                oCar.regY = oSprite.height/2;
                oCar.x = -350 + (i * iGiftSpacing); // Posición inicial ajustada
                oCar.y = 170;
                // oCar.scaleX = oCar.scaleY = 0.7;
                _oPanelContainer.addChild(oCar);
            }
        }

        // esconder el conteo de lo ganado en la partida de un nivel
        new createjs.Tween.get(_oPanelContainer).to({y:CANVAS_HEIGHT/2},500, createjs.Ease.quartIn)/*.call(function(){
            new CRollingText(oScoreText.getText(), iScore, 5000, false);
        })*/;
        this._sendScore();

        // var oSprite = s_oSpriteLibrary.getSprite('but_next');
        // _oContinueBut = new CGfxButton(180, 150, oSprite,_oPanelContainer);
        // _oContinueBut.addEventListener(ON_MOUSE_UP, this._onContinue, this);
        // _oContinueBut.pulseAnimation();

        var oSprite = s_oSpriteLibrary.getSprite('but_restart');
        _oRestartBut = new CGfxButton(460, -320, oSprite,_oPanelContainer);
        _oRestartBut.addEventListener(ON_MOUSE_UP, this._onRestart, this);
    };

    this.unload = function(){

        _oFade.off("mousedown",function(){});

        s_oStage.removeChild(_oFade);
        _oPanelContainer.removeAllChildren(_oFade);

        // _oContinueBut.unload();
        _oRestartBut.unload();

    };

    this._sendScore = function(){
        var iNewTimeScore = LEVEL_INFO[iLevel].time - iTimeElaps;

        s_iTotalScore += iScore;

        if(iNewTimeScore < s_aTimeScore[iLevel] || s_aTimeScore[iLevel] === 0){
            s_aTimeScore[iLevel] = iNewTimeScore;
        }

        s_oLocalStorage.saveData();

        $(s_oMain).trigger("save_score", s_iTotalScore);
    };

    this._onContinue = function(){

        _oRestartBut.setClickable(false);
        // _oContinueBut.setClickable(false);

        new createjs.Tween.get(_oFade).to({alpha:0},500);
        new createjs.Tween.get(_oPanelContainer).to({y:_pStartPanelPos.y},400, createjs.Ease.backIn).call(function(){
            _oParent.unload();
            s_oGame.nextLevel();
        });
    };

    this._onRestart = function(){
        _oRestartBut.setClickable(false);
        // _oContinueBut.setClickable(false);

        new createjs.Tween.get(_oFade).to({alpha:0},500);
        new createjs.Tween.get(_oPanelContainer).to({y:_pStartPanelPos.y},400, createjs.Ease.backIn).call(function(){
            _oParent.unload();
            s_oGame.restartGame();
        });
    };

    this._onFinishRolling = function(){

    };

    this._onRollingRemoved = function(){

    };

    this._onRollingText = function(iStep){

        _oAchievementStars.playManualMode(iStep, STAR_EFFECT_SCALE);

    };

    _oParent = this;
    this._init(iTimeElaps, iScore, iLevel, _iGiftsCaptured, _iCarsHitted);
}